<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../Date.xsl" />
<xsl:output method="text"/>
  
<xsl:template match="/softworkbench">
<xsl:variable name="table">
	<xsl:value-of select="@Table" />
</xsl:variable>
<xsl:variable name="tableschema">
  <xsl:value-of select="@TableSchema" />
</xsl:variable>
<xsl:variable name="database">
	<xsl:value-of select="@Database" />
</xsl:variable>
------------------------------------------------------------------------------------------------------
--Stored procedures were auto-generated by Softworkbench.SPGenerator
--Generated time: <xsl:value-of select="$date" />
--Web: http://www.softworkbench.com
--Email: info@softworkbench.com
------------------------------------------------------------------------------------------------------

GO
USE [<xsl:value-of select="$database"/>]
GO

--===============================================================
--[Stored Procedure generated for table: <xsl:value-of select="$table"/>]

<xsl:apply-templates select="//procedure" mode="body">
	<xsl:with-param name="tablename"><xsl:value-of select="$table"/></xsl:with-param>
  <xsl:with-param name="tableschemaname">
    <xsl:value-of select="$tableschema"/>
  </xsl:with-param>
</xsl:apply-templates>

--[End of Stored Procedure for table: <xsl:value-of select="$table"/>]
--===============================================================
</xsl:template>

<xsl:template match="procedure" mode="body">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
  
<xsl:choose >
		<xsl:when test='@type="READALL"'>
			<xsl:apply-templates select="//procedure" mode="readall">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
        <xsl:with-param name="tableschemaname">
          <xsl:value-of select="$tableschemaname"/>
        </xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="READ"'>
			<xsl:apply-templates select="//procedure" mode="read">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
        <xsl:with-param name="tableschemaname">
          <xsl:value-of select="$tableschemaname"/>
        </xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="INSERT"'>
			<xsl:apply-templates select="//procedure" mode="insert">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
        <xsl:with-param name="tableschemaname">
          <xsl:value-of select="$tableschemaname"/>
        </xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="UPDATE"'>
			<xsl:apply-templates select="//procedure" mode="update">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
        <xsl:with-param name="tableschemaname">
          <xsl:value-of select="$tableschemaname"/>
        </xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="DELETE"'>
			<xsl:apply-templates  select="//procedure" mode="delete">
				<xsl:with-param name="tablename"><xsl:value-of select="$tablename"/></xsl:with-param>
        <xsl:with-param name="tableschemaname">
          <xsl:value-of select="$tableschemaname"/>
        </xsl:with-param>
			</xsl:apply-templates>
		</xsl:when>
		<xsl:when test='@type="READALLFK"'>
			<xsl:if test='@type="READALLFK"'>

			<xsl:variable name="proc">
				<xsl:value-of select="@name"/>
			</xsl:variable>
-- //// Read all Stored Procedure based on foreign key
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
  drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
	<xsl:apply-templates select="foreignkey" mode="fk"/>	
AS
SET NOCOUNT ON

SELECT <xsl:for-each select="parameters//parameter">[<xsl:value-of select="@name"/>]<xsl:if test="not(position()=last())">,</xsl:if></xsl:for-each>
FROM [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
WHERE 	[<xsl:value-of select="foreignkey//@name"/>] = @<xsl:value-of select="foreignkey//@name"/>
GO

			</xsl:if>
		</xsl:when>
	</xsl:choose>

</xsl:template>

<xsl:template match="procedure" mode="delete">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
<xsl:variable name="proc">
	<xsl:value-of select="@name"/>
</xsl:variable>
<xsl:if test='@type="DELETE"'>
-- //// Delete Stored Procedure based on primary keys
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
<xsl:apply-templates select="//primarykey" mode="pk"/>
AS
SET NOCOUNT ON

DELETE FROM [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
WHERE <xsl:for-each select="//primarykey">[<xsl:value-of select="@name"/>] = @<xsl:value-of select="@name"/><xsl:if test="not(position()=last())"> AND </xsl:if></xsl:for-each>
GO
</xsl:if>
</xsl:template>

<xsl:template match="procedure" mode="readall">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
<xsl:variable name="proc">
<xsl:value-of select="@name"/>
</xsl:variable>
<xsl:if test='@type="READALL"'>
-- //// Read All Stored Procedures
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
    drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
AS
SET NOCOUNT ON

SELECT <xsl:for-each select="parameters//parameter"><xsl:value-of select="@name"/><xsl:if test="not(position()=last())">,</xsl:if></xsl:for-each>
FROM [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
GO
</xsl:if>
</xsl:template>


<xsl:template match="procedure" mode="insert">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
<xsl:variable name="proc">
	<xsl:value-of select="@name"/>
</xsl:variable>
<xsl:if test='@type="INSERT"'>
-- //// Insert Stored Procedure
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
  drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
	<xsl:apply-templates select="parameters//parameter" mode="param"><xsl:with-param name="proctype"><xsl:value-of select="@type"/></xsl:with-param></xsl:apply-templates>
AS
SET NOCOUNT ON

INSERT INTO  [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
(<xsl:for-each select="parameters//parameter">
	<xsl:choose>
		<xsl:when test="@IsIdentity='True'" />
		<xsl:otherwise>
			[<xsl:value-of select="@name"/>]<xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:for-each>
)
VALUES
(<xsl:for-each select="parameters//parameter">
	<xsl:choose>
		<xsl:when test="@IsIdentity='True'" />
		<xsl:otherwise>
			@<xsl:value-of select="@name"/><xsl:if test="not(position()=last())">,</xsl:if>
		</xsl:otherwise>
	</xsl:choose>
</xsl:for-each>
)
<xsl:for-each select="parameters//parameter[@IsIdentity='True']">
SET @<xsl:value-of select="@name" /> = @@IDENTITY
</xsl:for-each>
GO
</xsl:if>
</xsl:template>

<xsl:template match="procedure" mode="update">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
<xsl:if test='@type="UPDATE"'>
<xsl:variable name="proc">
	<xsl:value-of select="@name"/>
</xsl:variable>
-- //// Update Stored Procedure based on primary keys
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
	<xsl:apply-templates select="//primarykey" mode="pk"/>,
	<xsl:apply-templates select="parameters//parameter" mode="param"/>
AS
SET NOCOUNT ON

UPDATE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
SET
<xsl:for-each select="parameters//parameter">
	[<xsl:value-of select="@name"/>] = @<xsl:value-of select="@name"/><xsl:if test="not(position()=last())">,</xsl:if>
</xsl:for-each>
WHERE <xsl:for-each select="//primarykey">[<xsl:value-of select="@name"/>] = @<xsl:value-of select="@name"/><xsl:if test="not(position()=last())"> AND </xsl:if></xsl:for-each>

GO
</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="procedure" mode="read">
<xsl:param name="tablename"/>
<xsl:param name="tableschemaname"/>
<xsl:if test='@type="READ"'>

<xsl:variable name="proc">
	<xsl:value-of select="@name"/>
</xsl:variable>
-- //// Read Stored Procedure based on primary keys
if exists(select * from dbo.sysobjects where id = object_id(N'[<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]<br/>
GO

CREATE PROCEDURE [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$proc"/>]
	<xsl:apply-templates select="//primarykey" mode="pk"/>
AS
SET NOCOUNT ON

SELECT <xsl:for-each select="parameters//parameter">[<xsl:value-of select="@name"/>]<xsl:if test="not(position()=last())">,</xsl:if></xsl:for-each>
FROM [<xsl:value-of select="$tableschemaname"/>].[<xsl:value-of select="$tablename"/>]
WHERE <xsl:for-each select="//primarykey">[<xsl:value-of select="@name"/>] = @<xsl:value-of select="@name"/><xsl:if test="not(position()=last())"> AND </xsl:if></xsl:for-each>
GO
</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="parameter" mode="param">
<xsl:param name="proctype"/>
  <xsl:text>@</xsl:text>
  <xsl:value-of select="@name"/>
  
   <xsl:choose>
  <xsl:when test='@type="char"'> char(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varchar"'> varchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nchar"'> nchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nvarchar"'> nvarchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="binary"'> binary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varbinary"'> varbinary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="float"'> float(<xsl:value-of select="@precision"/>)</xsl:when>
  <xsl:when test='@type="decimal"'> decimal(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:when test='@type="numeric"'> numeric(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:otherwise><xsl:text> </xsl:text><xsl:value-of select="@type"/></xsl:otherwise> 
  </xsl:choose>
  <xsl:if test="$proctype='INSERT'">
  <xsl:if test="@IsIdentity='True'"> output</xsl:if>
  </xsl:if>
  <xsl:if test="not(position()=last())">,
	</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="primarykey" mode="pk">
  <xsl:text>@</xsl:text>
  <xsl:value-of select="@name"/>
  
  <xsl:choose>
  <xsl:when test='@type="char"'> char(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varchar"'> varchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nchar"'> nchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nvarchar"'> nvarchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="binary"'> binary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varbinary"'> varbinary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="float"'> float(<xsl:value-of select="@precision"/>)</xsl:when>
  <xsl:when test='@type="decimal"'> decimal(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:when test='@type="numeric"'> numeric(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:otherwise><xsl:text> </xsl:text><xsl:value-of select="@type"/></xsl:otherwise> 
  </xsl:choose>

  <xsl:if test="not(position()=last())">,
	</xsl:if>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
<xsl:template match="procedure//foreignkey" mode="fk">
  <xsl:text>@</xsl:text>
  <xsl:value-of select="@name"/>
  
   <xsl:choose>
  <xsl:when test='@type="char"'> char(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varchar"'> varchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nchar"'> nchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="nvarchar"'> nvarchar(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="binary"'> binary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="varbinary"'> varbinary(<xsl:value-of select="@length"/>)</xsl:when>
  <xsl:when test='@type="float"'> float(<xsl:value-of select="@precision"/>)</xsl:when>
  <xsl:when test='@type="decimal"'> decimal(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:when test='@type="numeric"'> numeric(<xsl:value-of select="@precision"/>, <xsl:value-of select="@scale"/>)</xsl:when>
  <xsl:otherwise><xsl:text> </xsl:text><xsl:value-of select="@type"/></xsl:otherwise> 
  </xsl:choose>
</xsl:template>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->
</xsl:stylesheet>

<!-- Copyright (c) Softworkbench, Inc., 2015 All Rights Reserved.-->
